//
// Cforall Version 1.0.0 Copyright (C) 2015 University of Waterloo
//
// The contents of this file are covered under the licence agreement in the
// file "LICENCE" distributed with Cforall.
//
// OperatorTable.h -- 
//
// Author           : Richard C. Bilson
// Created On       : Mon May 18 07:44:20 2015
// Last Modified By : Rob Schluntz
// Last Modified On : Wed Jun 24 16:17:57 2015
// Update Count     : 5
//

#ifndef _OPERATORTABLE_H
#define _OPERATORTABLE_H

#include <string>

namespace CodeGen {
	enum OperatorType {
		OT_INDEX,
		OT_CTOR,
		OT_DTOR,
		OT_CALL,
		OT_PREFIX,
		OT_POSTFIX,
		OT_INFIX,
		OT_PREFIXASSIGN,
		OT_POSTFIXASSIGN,
		OT_INFIXASSIGN,
		OT_LABELADDRESS,
		OT_CONSTANT
	};

	struct OperatorInfo {
		std::string inputName;
		std::string symbol;
		std::string outputName;
		OperatorType type;
	};

	bool operatorLookup( std::string funcName, OperatorInfo &info );
} // namespace CodeGen

#endif // _OPERATORTABLE_H

// Local Variables: //
// tab-width: 4 //
// mode: c++ //
// compile-command: "make install" //
// End: //
